#ifndef MCS_IO_H_
#define MCS_IO_H_

#include<fstream>
#include<iostream>
#include<cstdlib>
#include<iomanip>
#include<algorithm>
#include<sys/time.h>
#include"DATA_Patterns.h"
#include"mcsPatternFinding.h"
//#include"mcsClustering.h"
#include"mcsERPAP.h"
// #include"mcs_xml_io.h"


//**************************************************************************
//**************************************************************************


   typedef __gnu_cxx::hash_map<string,Molecule,StringHash,StringEq>           MoleculeMAP;
   typedef __gnu_cxx::hash_map<string,Molecule,StringHash,StringEq>::iterator MolMapITER;

   //typedef unordered_map<string,Molecule,StringHash,StringEq>           MoleculeMAP;
   //typedef unordered_map<string,Molecule,StringHash,StringEq>::iterator MolMapITER;


class mcsEnsemble
{
public:

                  	mcsEnsemble(const ExpaRNAOptions& newOptions) : ensOptions(newOptions)
                  	{
                  		load_input_data(ensOptions.cmdLineValues);
                  	};
	virtual			~mcsEnsemble() {};

   			void	startALL();

private:

   PatternPairMap 						ensemblePatterns;
   MoleculeMAP    						ensembleMolecules;
   PatternPairMap						ensembleMaxERPAP;

   ExpaRNAOptions	  					ensOptions;

   int 									sizeERPAP;

   void         clearEnsemble();
   void			load_input_data(const vector<string>& mydata);
   void         readFileInput2(string myFile1,Molecule& mol1,Molecule& mol2);
   string       getNext(std::ifstream &myFile, string& what, string& content);
   //void       updateEnsemblePatterns(const PatternPairMap& myPairMap);
   void			readFASTA(string myFASTAfile, Molecule& myMol1, Molecule& myMol2);
   //void         startClustering();
   void         startERPAP();
   void			output_LCSEPM();
   void			output_Clustal();
   void			output_LocARNA();
   void			extractMatchings();
  // void         writeClustersAsPS(const int& myClusterSaveCount,const bool writeXML);
 /*  void           writePatternMapAsPS(const Molecule& myMol1,
                                      const Molecule& myMol2,
                                      const PatternPairMap& myMap);*/
   void           clusterToPS(const Molecule& myMol1,
                              const Molecule& myMol2,
                              const string&	  myId,
                              const int&      mySize,
                              const PatternPairMap& myMap);
  // void           WriteAllToXML();
   void           printPatternMap();
};

#endif /*MCS_IO_H_*/
